# Widgets.pm - The Object Class that provides a Widgets Object
#$Id: Widgets.pm,v 1.1.1.1 2001/08/09 19:03:14 moreejt Exp $
#This package is released under the GNU General Public License.
#You should have recieved a copy of the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.

package Portal::Accounting::Widgets;
use strict;
use vars qw($AUTOLOAD $VERSION @ISA @EXPORT);

require Exporter;

@ISA = qw(Exporter AutoLoader);
@EXPORT = qw();
	
$VERSION = '0.02';

# new
# instantiates an instance of a Widgets
sub new
{
  my $that;
  $that = shift;
  my $class;
  $class = ref($that) || $that;
  my $self;
  $self = bless {}, $class;
#  my %args;
#  %args = (@_ );
  my $errStr;
  $errStr = "Portal::Accounting::Widgets->new() - Error!<br>\n";

  # do validation
  $self->{error} = !$self->isValid;
  if ($self->{error})
  {
    $self->{errorString} = $errStr . $self->{errorString};
  }

  return $self;
}

# isValid - Returns 0 or 1 to indicate if the object is valid.
sub isValid
{
  my $self;
  $self = shift;
  my $error;
  $error = 0;
  my $errorString;
  $errorString = "";
  my $errStr;
  $errStr = "Portal::Accounting::Widgets->isValid() - Error!<br>\n";

  $self->{error} = $error;
  $self->{errorString} = $errStr if $error;
  $self->{errorString} .= $errorString;

  return !$error;
}

sub DESTROY
{
  my $self;
  $self = shift;
}

sub AUTOLOAD
{
  my $self;
  $self = shift;
  my $type;
  $type = ref($self) || die "$self is not an object";
  my $name;
  $name = $AUTOLOAD;
  $name =~ s/.*://;	# strip fully-qualified portion
  unless (exists $self->{$name})
  {
    die "Can't access `$name' field in object of class $type";
  }
  if (@_)
  {
    return $self->{$name} = shift;
  }
  else
  {
    return $self->{$name};
  }
}

# setError
# requires: errorString
# returns: nothing
sub setError
{
  my $self;
  $self = shift;
  my %args;
  %args = ( errorString => "", @_ );
  my $errorString;
  $errorString = $args{errorString};
  
  $self->{errorString} = $errorString;
  $self->{error} = 1;
}

# didErrorOccur
# returns the value of error.
sub didErrorOccur
{
  my $self;
  $self= shift;

  return $self->{error};
}

# errorMessage
# returns the value of errorString
sub errorMessage
{
  my $self;
  $self = shift;

  return $self->{errorString};
}

sub setError
{
  my $self = shift;
  $self->{error} = 1;
  $self->{errorString} .= (@_);
  return undef;
}

#sum: this method will take a set of parameters then fill the sent in HTMLdoc with the data requested
#required args: doc=> HTMLObject, data => array of objects, name => name to be given to form element
#optional: size, all => t --include an All entry at the beginning, selectAll => --marks every entry as selected,
#selected => "[ALL][23532] 22 4223"--array of values to select in list, should be number/code
#noneString => a string to stand for selecting nothing in the list, noneValue =>the value of that entry
#onChange => javascript methods to run
sub printSelect
{
  my $self = shift;
  my %args = (@_, );
  my $doc;
  my $data;
  my $selected;
  my $size = -1;
  my $selectAll = "false";
  my $all = "false";
  my $multiple = (exists $args{multiple} ? $args{multiple} : "false");
  my $name = "";
  my $noneString = "";
  my $noneValue = "";
  my $onChange = "";
  my $selectstring;
  if (defined $args{doc})
  {
    $doc = $args{doc};
  }
  else
  {
    $self->setError("<b>Could not print Select. No HTMLObject sent in.</b>\n");
    return 0;
  }
  if (defined $args{data})
  {
    $data = $args{data};
  }
  else
  {
    $doc->print("<b>Could not print Select. No data defined</b>\n");
    return 0;
  }
  if (defined $args{name})
  {
    $name = $args{name};
  }
  else
  {
    $doc->print("<b>Could not print Select. No name defined</b>\n");
    return 0;
  }
  if (defined $args{selected})
  {
    $selected = $args{selected};
  }
  if (exists $args{all})
  {
    $all = "true";
  }
  if (exists $args{selectAll})
  {
    $selectAll = "true";
  }
  if (exists $args{noneString})
  {
    $noneString = $args{noneString};
  }
  if (exists $args{noneValue})
  {
    $noneValue = $args{noneValue};
  }
  if (defined $args{size})
  {
    $size = $args{size};
    if (not $size > 0)
    {
      $size = -1;
    }
  }
  if ($multiple !~ /^(true|false)$/)
  {
    $self->setError("<b>multiple = '$multiple' is invalid!</b>\n");
    return 0;
  }
  if ($selectAll eq "true" && $multiple eq "false")
  {
    $multiple = "true";  # you can't select all items if not a multi-select box!
  }
  #start the select box
  $doc->print("<select name=\"$name\"");
  if ($size > 0)
  {
    $doc->print(" size=\"$size\"");
  }
  if ($multiple eq "true")
  {
    $doc->print(" multiple");
  }
  if (defined $args{onChange})
  {
    $onChange = $args{onChange};
    $doc->print(" onChange=\"$onChange\"");
  }
  $doc->print(">\n");
  if ($noneString ne "" && $noneValue ne "")
  {
     $doc->print("  <option value=\"$noneValue\">$noneString\n");
  }
  if ($all eq "true")
  {
    $doc->print("  <option value=\"ALL\"");
    $selectstring = (grep (/ALL/,@{$selected}) > 0 || $selectAll eq "true" ? " selected":"");
    $doc->print($selectstring);
    $doc->print(">ALL\n");
  }

  my $index;
  foreach $index (@{$data})
  {
    $selectstring = (grep (/$index->{number}/,@{$selected}) > 0 || $selectAll eq "true" ? " selected":"");
    $doc->print("  <option value=\"$index->{number}\"$selectstring>" . $doc->formEncodeString(string => $index->{name}) . "\n");
  }

  $doc->print("</select>\n");
  return 1;
}

#Required
 #doc: an HTMLObject to print into
#Optional
 #name: the name to give to the form item
 #date: the default date to place in the boxes,
 #noFocus:  tells the method not to set the focus before entering text into the doc
 #noJava:   does not put javascript in place (mostly for when two or more boxes on the same screen
 #size:   defaults to 10
 #style:  split, noSplit, combo
sub printDateSelection
{
  my $self;
  $self = shift;
  my $doc;
  my %args;
  %args = ( @_ );
  my $date;
  $date = "";
  my $name;
  $name = "date";
  my $formName;
  $formName = "inputform";
  my $siteDir;
  $siteDir = $self->{portalConfig}->{siteDir};
  my $size;
  $size = "10";
  my $style;
  $style = "combo";

  if (!(defined $args{doc}))
  {
    $self->{error} = 1;
    $self->{errorString} = "No document sent to function displayDateSelection";
    return undef;
  }
  $doc = $args{doc};

  if (defined $args{date})
  {
    $date = $args{date};
  }
  if (defined $args{name})
  { #need to set to the input name
    $name = $args{name};
  }
  if (defined $args{formname})
  {
    $formName = $args{formname};
  }
  if (defined $args{size})
  {
    $size = $args{size};
  }
  if (defined $args{style})
  {
    $style = $args{style};
  }
  if (defined $args{size})
  {
    $size = $args{size};
  }

  my $focus;
  $focus = $doc->getFocus();

  if (! defined $args{'noFocus'})
  {
    $doc->setFocus("body");
  }
  $doc->print("<table>");
  $doc->print("<tr><td align=\"center\">");
  if ($style eq "combo" || $style eq "split")
  {
    $doc->print("D<input type=\"text\" size=3 name=\"d_$name\">");
    $doc->print("M<input type=\"text\" size=3 name=\"m_$name\">");
    $doc->print("Y<input size=3 type=\"text\" name=\"y_$name\"><br>");
  }
  if ($style eq "combo" || $style eq "noSplit")
  {
    $doc->print("<input type=\"text\" size=\"$size\" name=\"$name\" value=\"$date\">");
    $doc->print("<a href=\"#\" onClick=\"window.dateField = document.$formName.$name;calendar = window.open('widgets/calendar.html', 'cal', 'WIDTH=200,HEIGHT=400')\" onmouseover=\"window.status='PopUp Calendar'\"><img src=\"widgets/calendar.gif\" border=\"0\" alt=\"PopUp Calendar\"></a>");
    $doc->print("</td></tr></table>\n");
  }
  if (! defined $args{'noJava'} && $style eq "combo")
  {
    if (! defined $args{'noFocus'})
    {
      $doc->setFocus("javascript");
    }
    #insert javascript code for handling combo sync
  }
  if (! defined $args{'noFocus'})
  {
    $doc->setFocus($focus);
  }
  return 1;
}

1;
__END__

=head1 NAME

Widgets - Object used to build a Widgets Object Class.

=head1 SYNOPSIS

  use Portal::Accounting::Widgets;
  my $obj = Portal::Accounting::Widgets->new;
  if ($obj->didErrorOccur())
  {
    die $obj->errorMessage();
  }
=head1 DESCRIPTION

Widgets is an HTML Widgets class.  These widgets can be used to
quickly generate things like date selection and dropdown lists
without having to do the repetitive work yourself.  Just pass
in the information and arguments and it will generate the rest.

=head1 Exported FUNCTIONS

  scalar new()
    Creates a new instance of the Portal::Accounting::Widgets
    object.

  bool isValid(void)
    Returns 0 or 1 to indicate if the object is valid.  The error will
    be available via errorMessage().

  void setError(errorString)
    Sets error = 1 and $self->{errorString} = errorString.

  scalar didErrorOccur(void)
    Returns the value of error.

  scalar errorMessage(void)
    Returns the value of errorString.
    
  scalar printSelect(data, name, size, doc, all, selectAll, selected)
    prints the data sent in into the HTMLObject sent in; returns 0 or 1

  scalar printDateSelection(name, doc, date)
    name: the name to give to the form item
    doc: an HTMLObject to print into
    date: the default date to place in the boxes


  NOTE:  All data fields are accessible by specifying the object
         and pointing to the data member to be modified on the
         left-hand side of the assignment.
         Ex.  $obj->variable($newValue); or $value = $obj->variable;

=head1 AUTHOR

PC & Web Xperience, Inc. (mailto:admin@pcxperience.com)

=head1 SEE ALSO

perl(1), Portal(3), Portal::Accounting(3)

=cut
